package org.dromara.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.domain.bo.SenEventsMediaBo;
import org.dromara.domain.vo.SenEventsMediaVo;
import org.dromara.domain.SenEventsMedia;
import org.dromara.mapper.SenEventsMediaMapper;
import org.dromara.service.ISenEventsMediaService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 事件媒介
Service业务层处理
 *
 * @author luogang
 * @date 2024-09-19
 */
@RequiredArgsConstructor
@Service
public class SenEventsMediaServiceImpl implements ISenEventsMediaService {

    private final SenEventsMediaMapper baseMapper;

    /**
     * 查询事件媒介

     *
     * @param id 主键
     * @return 事件媒介

     */
    @Override
    public SenEventsMediaVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事件媒介
列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事件媒介
分页列表
     */
    @Override
    public TableDataInfo<SenEventsMediaVo> queryPageList(SenEventsMediaBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SenEventsMedia> lqw = buildQueryWrapper(bo);
        Page<SenEventsMediaVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事件媒介
列表
     *
     * @param bo 查询条件
     * @return 事件媒介
列表
     */
    @Override
    public List<SenEventsMediaVo> queryList(SenEventsMediaBo bo) {
        LambdaQueryWrapper<SenEventsMedia> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SenEventsMedia> buildQueryWrapper(SenEventsMediaBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SenEventsMedia> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getEventId() != null, SenEventsMedia::getEventId, bo.getEventId());
        lqw.eq(StringUtils.isNotBlank(bo.getMediaType()), SenEventsMedia::getMediaType, bo.getMediaType());
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), SenEventsMedia::getFileName, bo.getFileName());
        lqw.eq(StringUtils.isNotBlank(bo.getFilePath()), SenEventsMedia::getFilePath, bo.getFilePath());
        lqw.eq(bo.getDuration() != null, SenEventsMedia::getDuration, bo.getDuration());
        return lqw;
    }

    /**
     * 新增事件媒介

     *
     * @param bo 事件媒介

     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SenEventsMediaBo bo) {
        SenEventsMedia add = MapstructUtils.convert(bo, SenEventsMedia.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事件媒介

     *
     * @param bo 事件媒介

     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SenEventsMediaBo bo) {
        SenEventsMedia update = MapstructUtils.convert(bo, SenEventsMedia.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SenEventsMedia entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事件媒介
信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public SenEventsMediaVo getMediaByEventId(SenEventsMediaBo bo) {
        LambdaQueryWrapper<SenEventsMedia> lqw = new LambdaQueryWrapper<>();
        lqw.eq(SenEventsMedia::getEventId, bo.getEventId());
        return baseMapper.selectVoOne(lqw);
    }
}
